-- SQL6.5
use master
go
sp_dbremove dump3
go
sp_dropdevice DUMP3, DELFILE
go
declare @devno int
select @devno = max(convert(tinyint, substring(convert(binary(4), d.low), v.low, 1)))+1
from sysdevices d,  master.dbo.spt_values v
where v.type = 'E'
and v.number = 3
DISK INIT NAME = 'DUMP3', PHYSNAME = 'c:\MSSQL\data\dump3.dat', VDEVNO = @devno, SIZE = 24414
go
create database dump3 on DUMP3 = 50
go
use dump3
-- create
create table status (
  statusid int not null primary key,
  status varchar(20) not null unique
)

create table filename (
  filenameid int IDENTITY (1, 1) not null,
  filename varchar(255) not null,
  statusid int references dbo.status(statusid),
  CONSTRAINT PK_filename PRIMARY KEY CLUSTERED (
    filenameid
  )
)
CREATE UNIQUE INDEX idx_filename ON dbo.filename (filename)

create table fingerprinttype (
  fingerprinttypeid int IDENTITY (1, 1) not null,
  fingerprinttype varchar(100) not null,
  CONSTRAINT PK_fingerprinttype PRIMARY KEY CLUSTERED (
    fingerprinttypeid
  )
)
CREATE UNIQUE INDEX idx_fingerprinttype on dbo.fingerprinttype (fingerprinttype)

create table fingerprint (
  filenameid int references dbo.filename(filenameid),
  fingerprinttypeid int references dbo.fingerprinttype (fingerprinttypeid),
  fingerprint text
)
create unique index idx_unq_fingerprint on dbo.fingerprint (filenameid, fingerprinttypeid)

insert into status values (-1,'unknown')
insert into status values (0,'OK')
insert into status values (1,'too short')
insert into status values (2,'signature mismatch')
insert into status values (3,'not readable')
insert into status values (4,'invalid')
insert into status values (5,'corrupt')
insert into status values (6,'empty')
insert into status values (7,'missing')
go