/**
 * DuMP3 version morpheus_0.2.9 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.fingerprint.configure;

import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;

/**
 * This class ...
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.5 $
 */
public class MDFingerprintConfigBeanInfo extends SimpleBeanInfo {
  /**
   * <code>beanClass</code> MDFingerprintConfigBeanInfo - the Bean class this BeanInfo applies to.
   */
  private final static Class<MDFingerprintConfig> beanClass = MDFingerprintConfig.class;

  /**
   * Constructor
   */
  public MDFingerprintConfigBeanInfo() {
    super();
  }

  /**
   * @see java.beans.SimpleBeanInfo#getPropertyDescriptors()
   */
  @Override
  public PropertyDescriptor[] getPropertyDescriptors() {
    try {
      final PropertyDescriptor md = new PropertyDescriptor(MDFingerprintConfig.MSG_DIGEST, beanClass);
      md.setBound(true);
      md.setConstrained(true);
      md.setDisplayName("Message digest");
      md.setShortDescription("Message digest name (checksum algorithm).");
      md.setValue("enumerationValues", MDFingerprintConfig.getMessageDigests());
      // md.setPropertyEditorClass();
      final PropertyDescriptor[] rv = {
        md
      };
      return rv;
    } catch (final IntrospectionException e) {
      throw new Error(e.toString());
    }
  }

  /**
   * @see java.beans.SimpleBeanInfo#getBeanDescriptor()
   */
  @Override
  public BeanDescriptor getBeanDescriptor() {
    final BeanDescriptor bd = new BeanDescriptor(beanClass);
    return bd;
  }

  /**
   * @see java.beans.SimpleBeanInfo#getAdditionalBeanInfo()
   */
  @Override
  public BeanInfo[] getAdditionalBeanInfo() {
    return new BeanInfo[]{
      new FingerprintConfigBeanInfo()
    };
  }
}
