/**
 * DuMP3 version morpheus_0.2.9 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.gui;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import net.za.grasser.duplicate.fingerprint.configure.FingerprintConfig;
import net.za.grasser.duplicate.gui.beans.ConfigProperty;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Image;

/**
 * This class ...
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.7 $
 */
public class FingerprintConfigLabelProvider implements ITableLabelProvider {
  /**
   * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
   */
  public String getColumnText(final Object element, final int column_index) {
    if (element instanceof ConfigProperty) {
      final ConfigProperty bc = (ConfigProperty)element;
      if (column_index == 0) {
        return bc.getPropertyDescriptor().getDisplayName();
      }
      if (column_index == 1) {
        try {
          final Class< ? extends FingerprintConfig> cls = bc.getBeanInfoClass();
          final Method ref = cls.getMethod("getInstance", new Class[]{});
          final FingerprintConfig config = (FingerprintConfig)ref.invoke(null, new Object[]{});
          final Method m = bc.getPropertyDescriptor().getReadMethod();
          return m.invoke(config, new Object[]{}).toString();
        } catch (final NoSuchMethodException nsm) {
          nsm.printStackTrace();
        } catch (final IllegalAccessException ia) {
          ia.printStackTrace();
        } catch (final InvocationTargetException ite) {
          ite.printStackTrace();
        }
      }
    } else if (element instanceof String) {
      return (String)element;
    }
    return "?";
  }

  /**
   * @see org.eclipse.jface.viewers.IBaseLabelProvider#addListener(org.eclipse.jface.viewers.ILabelProviderListener)
   */
  public void addListener(final ILabelProviderListener ilabelproviderlistener) {
    // do nothing yet
  }

  /**
   * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
   */
  public void dispose() {
    // do nothing yet
  }

  /**
   * @see org.eclipse.jface.viewers.IBaseLabelProvider#isLabelProperty(java.lang.Object, java.lang.String)
   */
  public boolean isLabelProperty(final Object obj, final String s) {
    return false;
  }

  /**
   * @see org.eclipse.jface.viewers.IBaseLabelProvider#removeListener(org.eclipse.jface.viewers.ILabelProviderListener)
   */
  public void removeListener(final ILabelProviderListener ilabelproviderlistener) {
    // do nothing yet
  }

  /**
   * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
   */
  public Image getColumnImage(final Object element, final int column_index) {
    return null;
  }
}
